package com.gxwebsoft.shop.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.core.web.*;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.common.system.service.UserService;
import com.gxwebsoft.shop.entity.UserFollow;
import com.gxwebsoft.shop.param.UserFollowParam;
import com.gxwebsoft.shop.service.UserFollowService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 关注记录表控制器
 *
 * @author 科技小王子
 * @since 2022-11-25 19:04:43
 */
@Api(tags = "关注记录表管理")
@RestController
@RequestMapping("/api/shop/user-follow")
public class UserFollowController extends BaseController {
    @Resource
    private UserService userService;
    @Resource
    private UserFollowService userFollowService;
    @Resource
    private StringRedisTemplate stringRedisTemplate;

    private static final String SPLIT = ":";
    private static final String PREFIX_ENTITY_LIKE = "follow:user";
    private static final String PREFIX_USER_LIKE = "like:user";
    private static final String PREFIX_FOLLOWEE = "followee";
    private static final String PREFIX_FOLLOWER = "follower";

    @PreAuthorize("hasAuthority('shop:userFollow:list')")
    @OperationLog
    @ApiOperation("分页查询关注记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<UserFollow>> page(UserFollowParam param) {
        // 使用关联查询
        return success(userFollowService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userFollow:list')")
    @OperationLog
    @ApiOperation("查询全部关注记录表")
    @GetMapping()
    public ApiResult<List<UserFollow>> list(UserFollowParam param) {
        User loginUser = getLoginUser();
        if (loginUser != null) {
          param.setLoginUserId(getLoginUserId());
        }
        return success(userFollowService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userFollow:list')")
    @OperationLog
    @ApiOperation("根据id查询关注记录表")
    @GetMapping("/{id}")
    public ApiResult<UserFollow> get(@PathVariable("id") Integer id) {
        return success(userFollowService.getById(id));
        // 使用关联查询
        //return success(userFollowService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:userFollow:save')")
    @Transactional(rollbackFor = {Exception.class})
    @ApiOperation("添加关注记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserFollow userFollow) {
        User loginUser = getLoginUser();
        if (loginUser != null) {
          User toUser = userService.getById(userFollow.getShopId());
          final Integer userId = loginUser.getUserId();
          userFollow.setUserId(userId);
          // 取消关注
          if(userFollowService.count(new LambdaQueryWrapper<UserFollow>().eq(UserFollow::getShopId,userFollow.getShopId()).eq(UserFollow::getUserId,userId)) > 0){
            userFollowService.remove(new LambdaQueryWrapper<UserFollow>().eq(UserFollow::getShopId,userFollow.getShopId()).eq(UserFollow::getUserId,userId));
            // 从Redis集合中移除
            stringRedisTemplate.opsForZSet().remove(getFollowKey(userFollow.getShopId()),userId.toString());
            // 更新粉丝数
            if(toUser.getFans() > 0){
              toUser.setFans(toUser.getFans() - 1);
            }
            userService.updateById(toUser);
            // 更新关注数
            if(loginUser.getFollowers() > 0){
              loginUser.setFollowers(loginUser.getFollowers() - 1);
            }
            userService.updateById(loginUser);
            return success("已取消关注");
          }
          userFollowService.save(userFollow);
          // 更新粉丝数
          toUser.setFans(toUser.getFans() + 1);
          userService.updateById(toUser);
          // 更新关注数
          loginUser.setFollowers(toUser.getFollowers() + 1);
          userService.updateById(loginUser);
          // 放入redis的set集合
          stringRedisTemplate.opsForZSet().add(getFollowKey(userFollow.getShopId()),userId.toString(),1);
          return success("关注成功");
        }
        return fail("操作失败");
    }

    @PreAuthorize("hasAuthority('shop:userFollow:update')")
    @OperationLog
    @ApiOperation("修改关注记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserFollow userFollow) {
        if (userFollowService.updateById(userFollow)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userFollow:remove')")
    @OperationLog
    @ApiOperation("删除关注记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userFollowService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:userFollow:save')")
    @OperationLog
    @ApiOperation("批量添加关注记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserFollow> list) {
        if (userFollowService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userFollow:update')")
    @OperationLog
    @ApiOperation("批量修改关注记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserFollow> batchParam) {
        if (batchParam.update(userFollowService, "log_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userFollow:remove')")
    @OperationLog
    @ApiOperation("批量删除关注记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userFollowService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    /**
     * 某个用户的关注数
     * @return like:entity:[entityId] ->set(userId)
     */
    public static String getFollowKey(Integer userId) {
      return PREFIX_ENTITY_LIKE + SPLIT + userId;
    }


}
